// Ejercicio 5-3
//
// Transferencia de la planta
s=%s;
Gp=syslin("c",3000/((1+s/500)*(1+s/1000)*(1+s/1e5)))
zpk(Gp)
// Descomposición en fracciones simples.
Gp_s=Gp
Dfs=pfss(Gp_s)
// discretización
Ts=0.002;
Gp_z=ss2tf(dscr(tf2ss(Gp),Ts))
zpk(Gp_z)
// Transformación bilineal
Gp_w=ss2tf(bilin(Gp_z,[Ts/2,1,-Ts/2,1]))
zpk(Gp_w)
//
xdel;
pth=pwd()
pth=pth+"\bode_lin.sci"
exec(pth)
w=logspace(1,5,500);
frec=w/2/%pi;
[M,F,w]=bode_asym(Gp_w,w,0,"red");
// Corrección para error nulo al escalón
figure(2)
Gp2=Gp_w/s
[M,F,w]=bode_asym(Gp2,w,0,"red");

function [Gc]=atraso(a,wc)
    // Cálculo de la red de atraso en función 
    // de la atenuación y la frecuencia de corte
    s=%s;
    w0=wc/10;
    wp=w0/a;
    Gc=syslin("c",1+s/w0,1+s/wp);
endfunction;
//
// Compensación para Ancho de Banda
xdel(winsid())
Gc2=atraso(29,100)
GH1=Gp2*Gc2
w=logspace(-2,5,500);
frec=w/2/%pi;
[M,F,w]=bode_asym(GH1,w,0,"red");    
Gc=Gc2/s;
z=%z;
Gc_z=ss2tf(bilin(Gc,[2/Ts,-2/Ts,1,1]))
zpk(Gc_z)
//
// Compensación para Margen de Fase
Gc3=atraso(8.7,280)
GH2=Gp2*Gc3
w=logspace(-2,5,500);
frec=w/2/%pi;
[M,F,w]=bode_asym(GH2,w,0,"red");    
Gc=Gc3/s;
z=%z;
Gc_z=ss2tf(bilin(Gc,[2/Ts,-2/Ts,1,1]))
zpk(Gc_z)

// Calculo de la respuesta transitoria AB
xdel(winsid())
Tlc1=GH1/(1+GH1);
tiempo=0:0.0005:0.3; // Vector de Tiempos
Y=csim('step',tiempo,Tlc1); // Simulación
plot2d(tiempo,Y,color("blue"))
xgrid(color("gray"))
title('Respuesta a lazo cerrado')
//
// Calculo de la respuesta transitoria MF
//
Tlc2=GH2/(1+GH2);
tiempo=0:0.0005:0.3; // Vector de Tiempos
Y=csim('step',tiempo,Tlc2); // Simulación
plot2d(tiempo,Y,color("red"))
xgrid(color("gray"))
title('Respuesta a lazo cerrado')
